diff --git a/src/backend/commands/seclabel.c b/src/backend/commands/seclabel.c
index 324f2e7..30d7af8 100644
--- a/src/backend/commands/seclabel.c
+++ b/src/backend/commands/seclabel.c
@@ -260,6 +260,8 @@ SetSharedSecurityLabel(const ObjectAddress *object,
 	Datum		values[Natts_pg_shseclabel];
 	bool		nulls[Natts_pg_shseclabel];
 	bool		replaces[Natts_pg_shseclabel];
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/* Prepare to form or update a tuple, if necessary. */
 	memset(nulls, false, sizeof(nulls));
@@ -299,7 +301,8 @@ SetSharedSecurityLabel(const ObjectAddress *object,
 			replaces[Anum_pg_shseclabel_label - 1] = true;
 			newtup = heap_modify_tuple(oldtup, RelationGetDescr(pg_shseclabel),
 									   values, nulls, replaces);
-			simple_heap_update(pg_shseclabel, &oldtup->t_self, newtup);
+			simple_heap_update(pg_shseclabel, &oldtup->t_self, newtup,
+					&warm_update, &modified_attrs);
 		}
 	}
 	systable_endscan(scan);
@@ -310,12 +313,13 @@ SetSharedSecurityLabel(const ObjectAddress *object,
 		newtup = heap_form_tuple(RelationGetDescr(pg_shseclabel),
 								 values, nulls);
 		simple_heap_insert(pg_shseclabel, newtup);
+		warm_update = false;
 	}
 
 	/* Update indexes, if necessary */
 	if (newtup != NULL)
 	{
-		CatalogUpdateIndexes(pg_shseclabel, newtup);
+		CatalogUpdateIndexes(pg_shseclabel, newtup, warm_update, modified_attrs);
 		heap_freetuple(newtup);
 	}
 
@@ -339,6 +343,8 @@ SetSecurityLabel(const ObjectAddress *object,
 	Datum		values[Natts_pg_seclabel];
 	bool		nulls[Natts_pg_seclabel];
 	bool		replaces[Natts_pg_seclabel];
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/* Shared objects have their own security label catalog. */
 	if (IsSharedRelation(object->classId))
@@ -390,7 +396,8 @@ SetSecurityLabel(const ObjectAddress *object,
 			replaces[Anum_pg_seclabel_label - 1] = true;
 			newtup = heap_modify_tuple(oldtup, RelationGetDescr(pg_seclabel),
 									   values, nulls, replaces);
-			simple_heap_update(pg_seclabel, &oldtup->t_self, newtup);
+			simple_heap_update(pg_seclabel, &oldtup->t_self, newtup,
+					&warm_update, &modified_attrs);
 		}
 	}
 	systable_endscan(scan);
@@ -401,12 +408,13 @@ SetSecurityLabel(const ObjectAddress *object,
 		newtup = heap_form_tuple(RelationGetDescr(pg_seclabel),
 								 values, nulls);
 		simple_heap_insert(pg_seclabel, newtup);
+		warm_update = false;
 	}
 
 	/* Update indexes, if necessary */
 	if (newtup != NULL)
 	{
-		CatalogUpdateIndexes(pg_seclabel, newtup);
+		CatalogUpdateIndexes(pg_seclabel, newtup, warm_update, modified_attrs);
 		heap_freetuple(newtup);
 	}
 
diff --git a/src/backend/commands/sequence.c b/src/backend/commands/sequence.c
index 0c673f5..8d4d9a4 100644
--- a/src/backend/commands/sequence.c
+++ b/src/backend/commands/sequence.c
@@ -237,7 +237,7 @@ DefineSequence(ParseState *pstate, CreateSeqStmt *seq)
 
 	tuple = heap_form_tuple(tupDesc, pgs_values, pgs_nulls);
 	simple_heap_insert(rel, tuple);
-	CatalogUpdateIndexes(rel, tuple);
+	CatalogUpdateIndexes(rel, tuple, false, NULL);
 
 	heap_freetuple(tuple);
 	heap_close(rel, RowExclusiveLock);
@@ -419,6 +419,8 @@ AlterSequence(ParseState *pstate, AlterSeqStmt *stmt)
 	ObjectAddress address;
 	Relation	rel;
 	HeapTuple	tuple;
+	bool		warm_update;
+	Bitmapset	*modified_attrs;
 
 	/* Open and lock sequence. */
 	relid = RangeVarGetRelid(stmt->sequence, AccessShareLock, stmt->missing_ok);
@@ -504,8 +506,9 @@ AlterSequence(ParseState *pstate, AlterSeqStmt *stmt)
 
 	relation_close(seqrel, NoLock);
 
-	simple_heap_update(rel, &tuple->t_self, tuple);
-	CatalogUpdateIndexes(rel, tuple);
+	simple_heap_update(rel, &tuple->t_self, tuple, &warm_update,
+			&modified_attrs);
+	CatalogUpdateIndexes(rel, tuple, warm_update, modified_attrs);
 	heap_close(rel, RowExclusiveLock);
 
 	return address;
diff --git a/src/backend/commands/subscriptioncmds.c b/src/backend/commands/subscriptioncmds.c
index 2b6d322..ccabde1 100644
--- a/src/backend/commands/subscriptioncmds.c
+++ b/src/backend/commands/subscriptioncmds.c
@@ -277,7 +277,7 @@ CreateSubscription(CreateSubscriptionStmt *stmt)
 
 	/* Insert tuple into catalog. */
 	subid = simple_heap_insert(rel, tup);
-	CatalogUpdateIndexes(rel, tup);
+	CatalogUpdateIndexes(rel, tup, false, NULL);
 	heap_freetuple(tup);
 
 	recordDependencyOnOwner(SubscriptionRelationId, subid, owner);
@@ -339,6 +339,8 @@ AlterSubscription(AlterSubscriptionStmt *stmt)
 	char	   *conninfo;
 	char	   *slot_name;
 	List	   *publications;
+	bool		warm_update;
+	Bitmapset  *modified_attrs;
 
 	rel = heap_open(SubscriptionRelationId, RowExclusiveLock);
 
@@ -397,8 +399,8 @@ AlterSubscription(AlterSubscriptionStmt *stmt)
 							replaces);
 
 	/* Update the catalog. */
-	simple_heap_update(rel, &tup->t_self, tup);
-	CatalogUpdateIndexes(rel, tup);
+	simple_heap_update(rel, &tup->t_self, tup, &warm_update, &modified_attrs);
+	CatalogUpdateIndexes(rel, tup, warm_update, modified_attrs);
 
 	ObjectAddressSet(myself, SubscriptionRelationId, subid);
 
@@ -558,6 +560,8 @@ static void
 AlterSubscriptionOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 {
 	Form_pg_subscription form;
+	bool				 warm_update;
+	Bitmapset  			*modified_attrs;
 
 	form = (Form_pg_subscription) GETSTRUCT(tup);
 
@@ -577,8 +581,8 @@ AlterSubscriptionOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 			 errhint("The owner of an subscription must be a superuser.")));
 
 	form->subowner = newOwnerId;
-	simple_heap_update(rel, &tup->t_self, tup);
-	CatalogUpdateIndexes(rel, tup);
+	simple_heap_update(rel, &tup->t_self, tup, &warm_update, &modified_attrs);
+	CatalogUpdateIndexes(rel, tup, warm_update, modified_attrs);
 
 	/* Update owner dependency reference */
 	changeDependencyOnOwner(SubscriptionRelationId,
